      ******************************************************************
      *                                                                *
      *    STUDENT:      Longwisch, Wilbur                             *
      *    STUDENT NO.:  XX                                            *
      *    PROGRAM:      FINAL                                         *
      *                                                                *
      *    COURSE:       CIS 261-02                                    *
      *    INSTRUCTOR:   OLIVER                                        *
      *                                                                *
     0*    DATE DUE:     Monday, May 3, 1999                           *
      *                                                                *
      ******************************************************************
      *=================================================================
       IDENTIFICATION DIVISION.
      *-----------------------------------------------------------------
       PROGRAM-ID.       FINALPGM.
       AUTHOR.           Wilbur Longwisch.
       INSTALLATION.     Murray State University.
       DATE-WRITTEN.     99/04/27.
       DATE-COMPILED.
       SECURITY.         NA.

      *=================================================================
       ENVIRONMENT DIVISION.
      *-----------------------------------------------------------------
       CONFIGURATION SECTION.
       SOURCE-COMPUTER.  IBM-PC-MicroFocus-COBOL.
       OBJECT-COMPUTER.  IBM-PC-MicroFocus-COBOL.

       INPUT-OUTPUT SECTION.
       FILE-CONTROL.

           SELECT EMPLOYEE-FILE   ASSIGN TO DISK 'B:\EMP-FILE.DAT'
               ORGANIZATION IS LINE SEQUENTIAL.

           SELECT PAYROLL-FILE    ASSIGN TO DISK 'B:\PAY-FILE.DAT'
               ORGANIZATION IS LINE SEQUENTIAL.

           SELECT PAY-REPORT-FILE ASSIGN TO DISK 'B:\PAY-RPT.DOC'
               ORGANIZATION IS LINE SEQUENTIAL.

      *=================================================================
       DATA DIVISION.
      *-----------------------------------------------------------------
       FILE SECTION.
       FD  EMPLOYEE-FILE
           RECORD CONTAINS 105 CHARACTERS
           DATA RECORD IS emp-rec.
       01  emp-rec.
           05  er-id-num               PIC 9(09).
           05  er-name.
               10  er-last             PIC X(15).
               10  er-first            PIC X(15).
               10  er-middle           PIC X(01).
           05  er-address              PIC X(30).
           05  er-city                 PIC X(15).
           05  er-state                PIC X(02).
           05  er-zip                  PIC 9(05).
           05  er-pay-code             PIC X(01).
           05  er-pay-amount           PIC 9(04)V99.
           05  er-fed-filing-status    PIC 9(01).
           05  er-exemptions           PIC 9(01).
           05  er-health-plan.
               10  er-coverage         PIC 9(01).
               10  er-plan             PIC 9(01).
           05  er-retirement           PIC V9(02).

       FD  PAYROLL-FILE
           RECORD CONTAINS 11 CHARACTERS
           DATA RECORD IS pay-rec.
       01  pay-rec.
           05  pr-id-num               PIC 9(09).
           05  pr-hours                PIC 9(02).

       FD  PAY-REPORT-FILE
           RECORD CONTAINS 70 CHARACTERS
           DATA RECORD IS rpt-rec.
       01  rpt-rec                     PIC X(70).

      *-----------------------------------------------------------------
       WORKING-STORAGE SECTION.
       01  Flags-and-Switches.
           05  emp-file-eof            PIC X(01) VALUE 'N'.
           05  pay-file-eof            PIC X(01) VALUE 'N'.
           05  stop-processing         PIC X(01) VALUE 'N'.

       01  Constants.
           05  standard-deduction      PIC 9(02) VALUE 23.
           05  thousand                PIC X(08) VALUE 'THOUSAND'.
           05  hundred                 PIC X(07) VALUE 'HUNDRED'.
           05  dollars                 PIC X(11) VALUE 'DOLLARS AND'.
           05  cents                   PIC X(05) VALUE 'CENTS'.

       01  String-Values.
           05  combined-date           PIC X(17).
           05  combined-name           PIC X(31).
           05  combined-state          PIC X(25).

       01  Working-Variables.
           05  grosspay                PIC 9(05)V99.
           05  retirement              PIC 9(05)V99.
           05  health                  PIC 9(05)V99.
           05  taxable-income          PIC 9(05)V99.
           05  check-amount            PIC 9(05)V99.
           05  ky-income-tax           PIC 9(05)V99.
           05  fed-income-tax          PIC 9(05)V99.
           05  dasdi                   PIC 9(05)V99.
           05  medicare                PIC 9(05)V99.
           05  temp                    PIC 9(09)V99.
           05  id-num-1                PIC X(03).
           05  id-num-2                PIC X(02).
           05  id-num-3                PIC X(04).
           05  new-id-num              PIC X(11).
           05  id-test                 PIC X(09).

       01  Bonus-Working-Variables.
           05  ten-thousands           PIC 9(1).
           05  thousands               PIC 9(1).
           05  hundreds                PIC 9(1).
           05  teens                   PIC 9(1).
           05  tens                    PIC 9(1).
           05  ones                    PIC 9(1).
           05  check-dollars           PIC 9(05).
           05  check-cents             PIC V9(02).
           05  check-temp              PIC X(05).
           05  text-temp1              PIC X(18).
           05  text-temp2              PIC X(13).
           05  text-temp3              PIC X(25).
           05  temp-text               PIC X(70) VALUE ALL '*'.
           05  1000-txt                PIC X(09).
           05  100-txt                 PIC X(05).
           05  10-txt                  PIC X(09).
           05  1-txt                   PIC X(05).

       01  Month-Data.
           05  FILLER              PIC X(09) VALUE 'JANURAY  '.
           05  FILLER              PIC X(09) VALUE 'FEBRUARY '.
           05  FILLER              PIC X(09) VALUE 'MARCH    '.
           05  FILLER              PIC X(09) VALUE 'APRIL    '.
           05  FILLER              PIC X(09) VALUE 'MAY      '.
           05  FILLER              PIC X(09) VALUE 'JUNE     '.
           05  FILLER              PIC X(09) VALUE 'JULY     '.
           05  FILLER              PIC X(09) VALUE 'AUGUST   '.
           05  FILLER              PIC X(09) VALUE 'SEPTEMBER'.
           05  FILLER              PIC X(09) VALUE 'OCTOBER  '.
           05  FILLER              PIC X(09) VALUE 'NOVEMBER '.
           05  FILLER              PIC X(09) VALUE 'DECEMBER '.

       01  Month-Table REDEFINES Month-Data OCCURS 12 TIMES.
           05  mt-month pic X(09).

       01  Health-Data.
           05  FILLER              PIC X(12) VALUE '201000301505'.
           05  FILLER              PIC X(12) VALUE '352010402515'.

       01  Health-Ins-Table REDEFINES Health-Data OCCURS 4 TIMES.
           05  cc-preferred        PIC 9(02).
           05  cc-standard         PIC 9(02).
           05  cc-minimum          PIC 9(02).

       01  Federal-Data.
           05  FILLER              PIC X(10) VALUE '0817313654'.
           05  FILLER              PIC X(10) VALUE '0682712020'.

       01  Federal-Table REDEFINES Federal-Data OCCURS 4 TIMES.
           05  ft-deduction        PIC 999V99.

       01  Singles-Data.
           05  FILLER              PIC X(15) VALUE 'ONE  TWO  THREE'.
           05  FILLER              PIC X(15) VALUE 'FOUR FIVE SIX  '.
           05  FILLER              PIC X(15) VALUE 'SEVENEIGHTNINE '.

       01  Singles-Table REDEFINES Singles-Data OCCURS 9 TIMES.
           05  single-num          PIC X(05).

       01  Tens-Data.
           05  FILLER              PIC X(14) VALUE 'TEN    TWENTY '.
           05  FILLER              PIC X(14) VALUE 'THIRTY FOURTY '.
           05  FILLER              PIC X(14) VALUE 'FIFTY  SIXTY  '.
           05  FILLER              PIC X(14) VALUE 'SEVENTYEIGHTY '.
           05  FILLER              PIC X(07) VALUE 'NINETY '.

       01  Tens-Table REDEFINES Tens-Data OCCURS 9 TIMES.
           05  tens-num            PIC X(07).

       01  Teens-Data.
           05  FILLER              PIC X(18) VALUE 'ELEVEN   TWELVE   '.
           05  FILLER              PIC X(18) VALUE 'THIRTEEN FOURTEEN '.
           05  FILLER              PIC X(18) VALUE 'FIFTEEN  SIXTEEN  '.
           05  FILLER              PIC X(18) VALUE 'SEVENTEENEIGHTEEN '.
           05  FILLER              PIC X(09) VALUE 'NINETEEN '.

       01  Teens-Table REDEFINES Teens-Data OCCURS 9 TIMES.
           05  teens-num           PIC X(09).

       01  Blank-Line.
           05  FILLER                  PIC X(70) VALUE SPACES.

       01  Report-Date.
           05  RD-Year                 PIC 99.
           05  RD-Month                PIC 99.
           05  RD-Day                  PIC 99.

       01  Check-Printout.
           05  FILLER                  PIC X(13) VALUE SPACES.
           05  cp-date                 PIC X(17).
           05  FILLER                  PIC X(40) VALUE SPACES.

       01  Check-Printout-2.
           05  FILLER                  PIC X(11) VALUE SPACES.
           05  cp2-name                PIC X(31).
           05  FILLER                  PIC X(06) VALUE SPACES.
           05  FILLER                  PIC X(01) VALUE '$'.
           05  cp2-amount              PIC ****9.99.
           05  FILLER                  PIC X(13) VALUE SPACES.

       01  Check-Printout-3.
           05  FILLER                  PIC X(11) VALUE SPACES.
           05  cp3-address             PIC X(30).
           05  FILLER                  PIC X(29) VALUE SPACES.

       01  Check-Printout-4.
           05  FILLER                  PIC X(11) VALUE SPACES.
           05  cp4-location            PIC X(25).
           05  FILLER                  PIC X(34) VALUE SPACES.

       01  Check-Printout-5.
           05  cp5-desc                PIC X(70).

       01  Deco-Line.
           05  FILLER                  PIC X(70) VALUE ALL '-'.

       01  Withholdings-Statement.
           05  FILLER                  PIC X(09) VALUE 'EMPLOYEE:'.
           05  FILLER                  PIC X(19) VALUE SPACES.
           05  ws-name                 PIC X(31).
           05  FILLER                  PIC X(11) VALUE SPACES.

       01  Withholdings-Statement-2.
           05  FILLER                  PIC X(22) VALUE
               'SOCIAL SECURITY NUMBER'.
           05  FILLER                  PIC X(06) VALUE SPACES.
           05  ws-id-num               PIC X(11).
           05  FILLER                  PIC X(31) VALUE SPACES.

       01  Withholdings-Statement-3.
           05  FILLER                  PIC X(13) VALUE 'PAYROLL DATE:'.
           05  FILLER                  PIC X(15) VALUE SPACES.
           05  ws-date                 PIC X(17).
           05  FILLER                  PIC X(25) VALUE SPACES.

       01  Withholdings-Statement-4.
           05  ws-desc                 PIC X(28).
           05  FILLER                  PIC X(01) VALUE '$'.
           05  ws-gross-pay            PIC Z,ZZ9.99.
           05  FILLER                  PIC X(33) VALUE SPACES.

       01  Withholdings-Statement-5.
           05  ws2-desc                PIC X(29).
           05  ws2-gross-pay           PIC Z,ZZ9.99.
           05  FILLER                  PIC X(33) VALUE SPACES.

       01  Withholding-Deco.
           05  FILLER                  PIC X(28) VALUE SPACES.
           05  FILLER                  PIC X(09) VALUE ALL '-'.
           05  FILLER                  PIC X(33) VALUE SPACES.

       01  Withholding-Deco-2.
           05  FILLER                  PIC X(28) VALUE SPACES.
           05  FILLER                  PIC X(09) VALUE ALL '='.
           05  FILLER                  PIC X(33) VALUE SPACES.

      *=================================================================
       PROCEDURE DIVISION.
      *-----------------------------------------------------------------
       0000-Main-Control.
           PERFORM 1000-Initialize.
           PERFORM 4000-Process-Data UNTIL stop-processing = 'Y'.
           PERFORM 9000-Terminate-Program.
           STOP RUN.

      *-----------------------------------------------------------------
       1000-Initialize.
           OPEN INPUT  EMPLOYEE-FILE
                INPUT  PAYROLL-FILE
                OUTPUT PAY-REPORT-FILE.

           INITIALIZE Working-Variables.
           INITIALIZE Bonus-Working-Variables.

           ACCEPT Report-Date    FROM DATE.

           PERFORM 2000-Read-EMPLOYEE-FILE.
           PERFORM 2001-Read-PAYROLL-FILE.

      *-----------------------------------------------------------------
       2000-Read-EMPLOYEE-FILE.
           READ EMPLOYEE-FILE
               AT END MOVE 'Y'   TO emp-file-eof
           END-READ.

      *-----------------------------------------------------------------
       2001-Read-PAYROLL-FILE.
           READ PAYROLL-FILE
               AT END MOVE 'Y'   TO pay-file-eof
           END-READ.

      *-----------------------------------------------------------------
       4000-Process-Data.
           IF er-id-num < pr-id-num
      *        Do not pay employeee in employee record
               PERFORM 2000-Read-EMPLOYEE-FILE
           ELSE
               IF er-id-num = pr-id-num
                   PERFORM 4001-Compute-Pay
                   PERFORM 4002-Create-Strings
                   IF pr-hours > 0 OR er-pay-code = 'S'
                       PERFORM 5000-Print-Check
                   END-IF
                   PERFORM 2000-Read-EMPLOYEE-FILE
                   PERFORM 2001-Read-PAYROLL-FILE
               ELSE
                   PERFORM 4002-Create-Strings
                   PERFORM 5000-Print-Check
                   PERFORM 2001-Read-PAYROLL-FILE
               END-IF
           END-IF.

      *Statement to signal end of record processing
           IF emp-file-eof = 'Y' AND pay-file-eof = 'Y'
               MOVE 'Y' TO stop-processing
           END-IF.

      *-----------------------------------------------------------------
       4001-Compute-Pay.
      *1)  Figure Gross Pay
           IF er-pay-code = 'S'
      *        compute salary amount
               MOVE er-pay-amount                 TO grosspay
           ELSE
      *        compute hourly amount
               IF pr-hours > 40
                   COMPUTE grosspay = (er-pay-amount * 40) +
                   (er-pay-amount * 1.5 * (pr-hours - 40))
               ELSE
                   COMPUTE grosspay = er-pay-amount * pr-hours
               END-IF
           END-IF.

      *2)  Figure Taxable Income

      *2a) Figure Retirement Withholding
           COMPUTE retirement = grosspay * er-retirement.

      *2b) Figure Health Withholding
           IF er-plan = 3
               MOVE cc-minimum(er-coverage)       TO health
           ELSE
               IF er-plan = 2
                   MOVE cc-standard(er-coverage)  TO health
               ELSE
                   MOVE cc-preferred(er-coverage) TO health
               END-IF
           END-IF.

      *2c) Subtract retirement and health from grosspay
           COMPUTE taxable-income = grosspay - retirement - health.

      *3)  Figure Net Income

      *3a) Figure Kentucky Income Tax
           COMPUTE temp = taxable-income - standard-deduction.
           IF temp <= 58 AND temp >= 0
               MOVE ZERO TO ky-income-tax
           ELSE
               IF temp <= 77 AND temp > 58
                   COMPUTE ky-income-tax = ((temp - 58) * .03) + 1.16 -
                   (.5 * er-exemptions)
               ELSE
                   IF temp <= 97 AND temp > 77
                       COMPUTE ky-income-tax = ((temp - 77) * .04) +
                       1.73 - (.5 * er-exemptions)
                   ELSE
                       IF temp <= 154 AND temp > 97
                           COMPUTE ky-income-tax = ((temp - 97) * .05) +
                           2.50 - (.5 * er-exemptions)
                       ELSE
                           IF temp > 154
                               COMPUTE ky-income-tax = ((temp - 154) *
                               .06) + 5.39 - (.5 * er-exemptions)
                           END-IF
                       END-IF
                   END-IF
               END-IF
           END-IF.

      *3b) Figure Federal Income Tax
           COMPUTE temp = taxable-income -
           ft-deduction(er-fed-filing-status) - (51.93 * er-exemptions)
           IF er-fed-filing-status > 1 AND er-fed-filing-status < 4
               PERFORM 4004-Fed-Married-J-or-S
           ELSE
               PERFORM 4003-Fed-Single-or-Head
           END-IF.

      *3c) Figure FICA-DASDI (Social Security)
           COMPUTE dasdi = taxable-income * .062.

      *3d) Figure FICA-Medicare
           COMPUTE medicare = taxable-income * .0145.

      *4)  Figure Take home pay
           COMPUTE check-amount = grosspay - ky-income-tax -
           fed-income-tax - health - dasdi - medicare - retirement.

      *-----------------------------------------------------------------
       4002-Create-Strings.
      *--------------------------Date String----------------------------
           STRING mt-month(rd-month) DELIMITED BY SPACE
           ' '                       DELIMITED BY SIZE
                  rd-day             DELIMITED BY SPACE
           ', '                      DELIMITED BY SIZE
                  rd-year            DELIMITED BY SPACE
           INTO   combined-date
           END-STRING.

      *--------------------------Name String----------------------------
           STRING er-first           DELIMITED BY SPACE
           ' '                       DELIMITED BY SIZE
                  er-last            DELIMITED BY SPACE
           INTO   combined-name
           END-STRING.

      *--------------------------City String----------------------------
           STRING er-city            DELIMITED BY SPACE
           ', '                      DELIMITED BY SIZE
                  er-state           DELIMITED BY SPACE
           ' '                       DELIMITED BY SIZE
                  er-zip             DELIMITED BY SPACE
           INTO   combined-state
           END-STRING.

      *----------------------------ID String----------------------------
           MOVE er-id-num TO id-test.

           UNSTRING id-test INTO id-num-1 id-num-2 id-num-3
           END-UNSTRING.

           STRING id-num-1           DELIMITED BY SPACE
           '-'                       DELIMITED BY SIZE
                  id-num-2           DELIMITED BY SPACE
           '-'                       DELIMITED BY SIZE
                  id-num-3           DELIMITED BY SPACE
           INTO   new-id-num
           END-STRING.

      *-----------------------------------------------------------------
       4003-Fed-Single-or-Head.
           IF temp <= 54 AND temp >= 0
               MOVE ZERO TO fed-income-tax
           ELSE
               IF temp <= 525 AND temp > 54
                   COMPUTE fed-income-tax = ((temp - 54) * .15)
               ELSE
                   IF temp <= 1125 AND temp > 525
                       COMPUTE fed-income-tax = ((temp - 525) * .28)
                       + 71.10
                   ELSE
                       IF temp <= 2535 AND temp > 1125
                           COMPUTE fed-income-tax = ((temp - 1125) *
                           .31) + 239.10
                       ELSE
                           IF temp <= 5475 AND temp > 2535
                               COMPUTE fed-income-tax = ((temp - 2535)
                               * .36) + 676.05
                           ELSE
                               IF temp > 5475
                                   COMPUTE fed-income-tax = ((temp -
                                   5475) * .40) + 1734.63
                               END-IF
                           END-IF
                       END-IF
                   END-IF
               END-IF
           END-IF.

      *-----------------------------------------------------------------
       4004-Fed-Married-J-or-S.
           IF temp <= 125 AND temp >= 0
               MOVE ZERO TO fed-income-tax
           ELSE
               IF temp <= 909 AND temp > 125
                   COMPUTE fed-income-tax = ((temp - 125) * .15)
               ELSE
                   IF temp <= 1894 AND temp > 909
                       COMPUTE fed-income-tax = ((temp - 909) * .28)
                       + 118.43
                   ELSE
                       IF temp <= 3135 AND temp > 1894
                           COMPUTE fed-income-tax = ((temp - 1894) *
                           .31) + 392.97
                       ELSE
                           IF temp <= 5531 AND temp > 3135
                               COMPUTE fed-income-tax = ((temp - 3135)
                               * .36) + 777.52
                           ELSE
                               IF temp > 5531
                                   COMPUTE fed-income-tax = ((temp -
                                   5531) * .40) + 1640.26
                               END-IF
                           END-IF
                       END-IF
                   END-IF
               END-IF
           END-IF.

      *-----------------------------------------------------------------
       5000-Print-Check.
      *Moving data to check record
           MOVE combined-date  TO cp-date.
           MOVE combined-name  TO cp2-name.
           MOVE check-amount   TO cp2-amount.
           MOVE er-address     TO cp3-address.
           MOVE combined-state TO cp4-location.

      *Moving data to check-stub record
           MOVE combined-name  TO ws-name.
           MOVE new-id-num     TO ws-id-num.
           MOVE combined-date  TO ws-date.
           MOVE grosspay       TO ws-gross-pay.
           MOVE 'GROSS PAY'    TO ws-desc.

           COMPUTE temp = fed-income-tax + dasdi + medicare +
           ky-income-tax + retirement + health.

           PERFORM 5001-Create-Words-For-Check.

           WRITE rpt-rec   FROM blank-line               AFTER PAGE.
           WRITE rpt-rec   FROM check-printout           AFTER 5 LINES.
           WRITE rpt-rec   FROM check-printout-2         AFTER 2 LINES.
           WRITE rpt-rec   FROM check-printout-3         AFTER 1 LINES.
           WRITE rpt-rec   FROM check-printout-4         AFTER 1 LINES.
           WRITE rpt-rec   FROM check-printout-5         AFTER 3 LINES.

           WRITE rpt-rec   FROM Deco-Line                AFTER 10 LINES.
           WRITE rpt-rec   FROM Withholdings-Statement   AFTER  1 LINES.
           WRITE rpt-rec   FROM Withholdings-Statement-2 AFTER  2 LINES.
           WRITE rpt-rec   FROM Withholdings-Statement-3 AFTER  2 LINES.
           WRITE rpt-rec   FROM Deco-Line                AFTER  1 LINES.
           WRITE rpt-rec   FROM Withholdings-Statement-4 AFTER  2 LINES.
           WRITE rpt-rec   FROM Withholding-Deco         AFTER  1 LINES.

           MOVE fed-income-tax              TO ws-gross-pay.
           MOVE 'FEDERAL TAX WITHHOLDING'   TO ws-desc.
           WRITE rpt-rec   FROM Withholdings-Statement-4 AFTER  1 LINES.

           MOVE dasdi                       TO ws2-gross-pay.
           MOVE 'FICA - DASDI'              TO ws2-desc.
           WRITE rpt-rec   FROM Withholdings-Statement-5 AFTER  1 LINES.

           MOVE medicare                    TO ws2-gross-pay.
           MOVE 'FICA - MEDICARE'           TO ws2-desc.
           WRITE rpt-rec   FROM Withholdings-Statement-5 AFTER  1 LINES.

           MOVE ky-income-tax               TO ws2-gross-pay.
           MOVE 'KENTUCKY TAX WITHHOLDING'  TO ws2-desc.
           WRITE rpt-rec   FROM Withholdings-Statement-5 AFTER  1 LINES.

           MOVE retirement                  TO ws2-gross-pay.
           MOVE 'RETIREMENT CONTRIBUTION'   TO ws2-desc.
           WRITE rpt-rec   FROM Withholdings-Statement-5 AFTER  1 LINES.

           MOVE health                      TO ws2-gross-pay.
           MOVE 'HEALTH INSURANCE'          TO ws2-desc.
           WRITE rpt-rec   FROM Withholdings-Statement-5 AFTER  1 LINES.
           WRITE rpt-rec   FROM Withholding-Deco         AFTER  1 LINES.

           MOVE temp                        TO ws-gross-pay.
           MOVE 'TOTAL REDUCTIONS TO GROSS' TO ws-desc.
           WRITE rpt-rec   FROM Withholdings-Statement-4 AFTER  1 LINES.
           WRITE rpt-rec   FROM Withholding-Deco         AFTER  1 LINES.

           MOVE check-amount                TO ws-gross-pay.
           MOVE 'NET PAY'                   TO ws-desc.
           WRITE rpt-rec   FROM Withholdings-Statement-4 AFTER  1 LINES.
           WRITE rpt-rec   FROM Withholding-Deco-2       AFTER  1 LINES.

           MOVE SPACES TO combined-date, combined-name, combined-state.
           INITIALIZE Working-Variables, Bonus-Working-Variables.

      *-----------------------------------------------------------------
       5001-Create-Words-For-Check.
           MOVE check-amount   TO check-dollars, check-cents.
           MOVE check-dollars  TO check-temp.

           UNSTRING CHECK-TEMP INTO ten-thousands thousands hundreds
           tens ones
           END-UNSTRING.

           IF ten-thousands > 0
               IF ten-thousands > 1
                   MOVE tens-num(ten-thousands)     TO 1000-txt
               ELSE
                   IF thousands = 0
                       MOVE tens-num(ten-thousands) TO 1000-txt
                   ELSE
                       MOVE teens-num(thousands)    TO 1000-txt
                   END-IF
               END-IF
           END-IF.

           IF  thousands > 0
               IF ten-thousands = 0 OR ten-thousands > 1
                   MOVE single-num(thousands) TO 1000-txt
               ELSE
                   NEXT SENTENCE
               END-IF
           ELSE
               NEXT SENTENCE
           END-IF.

           IF ten-thousands > 1 OR thousands > 0
               STRING 1000-txt         DELIMITED BY SPACE
               ' '                     DELIMITED BY SIZE
                      thousand         DELIMITED BY SPACE
               ', '                    DELIMITED BY SIZE
               INTO   text-temp1
               END-STRING
           END-IF.

           IF hundreds > 0
               MOVE single-num(hundreds) TO 100-txt
               STRING 100-txt          DELIMITED BY SPACE
               ' '                     DELIMITED BY SIZE
                      hundred          DELIMITED BY SPACE
               ', '                    DELIMITED BY SIZE
               INTO   text-temp2
               END-STRING
           END-IF.

           IF tens > 0
               IF tens = 1
                   IF ones = 0
                       MOVE tens-num(tens)  TO 10-txt
                   ELSE
                       MOVE teens-num(ones) TO 10-txt
                   END-IF
               ELSE
                   MOVE tens-num(tens) TO 10-txt
               END-IF
           END-IF.

           IF ones > 0 AND ( tens > 1  OR tens < 1 )
               MOVE single-num(ones)   TO 1-txt
           END-IF.

           IF tens > 0 OR ones > 0
               STRING 10-txt           DELIMITED BY SPACE
               ' '                     DELIMITED BY SIZE
                      1-txt            DELIMITED BY SPACE
               ' '                     DELIMITED BY SIZE
                      dollars          DELIMITED BY '.'
               ', '                    DELIMITED BY SIZE
               INTO   text-temp3
               END-STRING
           END-IF.

           IF ten-thousands > 1 OR thousands > 0
               STRING text-temp1       DELIMITED BY ','
               ' '                     DELIMITED BY SIZE
                      text-temp2       DELIMITED BY ','
               ' '                     DELIMITED BY SIZE
                      text-temp3       DELIMITED BY ','
               ' '                     DELIMITED BY SIZE
                      check-cents      DELIMITED BY SPACE
               ' '                     DELIMITED BY SIZE
                      cents            DELIMITED BY SPACE
               INTO temp-text
               END-STRING
           ELSE
               STRING text-temp2       DELIMITED BY ','
               ' '                     DELIMITED BY SIZE
                      text-temp3       DELIMITED BY ','
               ' '                     DELIMITED BY SIZE
                      check-cents      DELIMITED BY SPACE
               ' '                     DELIMITED BY SIZE
                      cents            DELIMITED BY SPACE
               INTO temp-text
               END-STRING
           END-IF.

           MOVE temp-text              TO cp5-desc.

      *-----------------------------------------------------------------
       9000-Terminate-Program.
           CLOSE EMPLOYEE-FILE
                 PAYROLL-FILE
                 PAY-REPORT-FILE.
